import { useRef, useState } from "react";
import "./index.less";
import { IButton } from "./props";

/**
 * Button组件
 */
export default function Button(props: IButton) {
  const sizeTable = {
    small: "12px",
    large: "16px",
  };
  const [animation, setAnimation] = useState(false);

  const onClick = () => {
    setAnimation(true);
    setTimeout(() => {
      setAnimation(false);
    }, 250);
    console.log("click event handler");
  };
  return (
    <>
      {
        <button
          onClick={onClick}
          className={animation ? "halo" : ""}
          style={{ fontSize: sizeTable[props.size] }}
        >
          {props.children}
        </button>
      }
    </>
  );
}
